'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
$Include "SHAKESORT.Inc"
sub RQShakeSort(X() as integer, N as integer)
    defint L, R, K, J
    L = 2
    R = N
    K = N
    do
      for J = R to L step -1
        if (X(J) < X(J - 1)) then
            Swap(X(J), X(J - 1))
            K = J
        end if
      next
      L = K + 1
      for J = L to R
        if (X(J) < X(J - 1)) then
            Swap(X(J), X(J - 1))
            K = J
        end if
      next
      R = K - 1
    loop until L >= R
end sub

DefStr sInput
DefInt N
' ---- SORT WITH FBASM Function
DefInt iArray1 (0 To 11) = {7,6,5,4,9,3,2,1,0,9,0,8}
'
Print "FBASM Before: ";
For N = 0 To 11
    Print iArray1(N);" ";
Next N
Print
'
DefInt iPtr = VarPtr(iArray1(0))
DefInt iRet = SHAKESORT (ptrSHAKESORT, Varptr(iPtr), 11,0,0)
Print "FBASM  After: ";
For N = 0 To 11
    Print iArray1(N);" ";
Next N
Print
Print
'
' ---- SORT WITH RAPIDQ SUB
DefInt iArray2 (1 To 12) = {7,6,5,4,9,3,2,1,0,9,0,8}
'
Print "RQ Before: ";
For N = 1 To 12
    Print iArray2(N);" ";
Next N
Print
'
RQShakeSort(iArray2(), 12)
Print "RQ  After: ";
For N = 1 To 12
    Print iArray2(N);" ";
Next N
Print

' ----- LARGE RANDOM ARRAY ----
DefInt iUBound = 499
DefInt iArrayC (0 To iUBound)
DefSng sngChrono
DefInt flagError = 0
'
Randomize Timer
' ---- WITH FBASM ----
For N = 0 To iUBound
    iArrayC(N) = ((-1) ^ (Int(2 * rnd))) * (10000 * rnd)
Next N
Print
Print 
sngChrono = Timer
iPtr = VarPtr(iArrayC(0))
ShakeSort (ptrSHAKESORT, VarPtr(iPtr), 499,0,0)
sngChrono = Timer - sngChrono
' Verify
For N = 0 To iUBound - 1
    If iArrayC(N) > iArrayC(N+1) Then
        Inc (flagError)
        ShowMessage (Str$(N) & ": " & Str$(iArrayC(N)) & " - " & Str$(N + 1) & ": " & Str$(iArrayC(N + 1)))
    End If
Next N
Print "ARRAY OF ";iUBound + 1;" INTEGERS SORTED WITH FBASM IN ";sngChrono," s  SORT ERRORS: ";flagError
'
'
' ---- WITH RAPIDQ ----
flagError = 0
For N = 1 To iUBound + 1
    iArrayC(N) = ((-1) ^ (Int(2 * rnd))) * (10000 * rnd)
Next N
Print
Print 
sngChrono = Timer
RQShakeSort (iArrayC(), iUBound + 1)
sngChrono = Timer - sngChrono
' Verify
For N = 0 To iUBound
    If iArrayC(N) > iArrayC(N+1) Then
        Inc (flagError)
        ShowMessage (Str$(N) & ": " & Str$(iArrayC(N)) & " - " & Str$(N + 1) & ": " & Str$(iArrayC(N + 1)))
    End If
Next N
Print "ARRAY OF ";iUBound + 1;" INTEGERS SORTED WITH QSRQ IN ";sngChrono," s  SORT ERRORS: ";flagError
'
' ----------------------------------------------------------------------
DefStr sInput2:Input sInput2:Application.Terminate
' ----------------------------------------------------------------------
'
